using System;
using MVR.FileManagementSecure;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using SimpleJSON;
using System.Linq;

using AssetBundles;

using UnityEngine.UI;

namespace NeMech 
{

	public class moanLight: MVRScript, TriggerHandler
    {

    	const string virsionMmsg = "<b>=== NeMech moanLight V1.0 ===</b>\n" + 
		                           "CC-BY-ND Content.\n" +
    	                           "<color=purple>Alteration prohibited.</color>\n" +
		                           "moanLight.cs\n" +
		                           "Created by NeMech in 2022/12\n" +
		                           "LastUpdate by Nemech in 2022/12 \n" +
		                           "https://www.patreon.com/nemech\n\n";

    	/***** Choice *****/
    	private string choiceColection;
    	
    	/***** for Audio ****/
		private JSONStorableBool sampleMoan;
    	private JSONStorableBool AutoToIdole;

    	private int bkSound;
		private string moanLib;
		private bool atIdole;
    	
    	private AudioSourceControl headAudioSource;

    	private List<string>[] audioLib = new List<string>[8];
    	int[] audioLib_count = new int[8];

		/***** for Arousal *****/
		const float MaxArousalCount = 700f;

    	const float ArousalLV1 = 250f;  // LV0 - LV1
    	const float ArousalLV2 = 450f;  // LV1 - LV2
    	const float ArousalLV3 = 600f;  // LV2 - LV4
    									// MAX   LV5

    	private JSONStorableBool playLoopState;
    	protected float sensitiv;

    	public float ArousalCount;
    	public int ArousalLVL;
    	private float lastCountTime;

    	/***** for CreateTrigger *****/
		protected List<EventTrigger> moanTriggers;
    	public override void Init()
        {

        	try
            {
            	moanTriggers = new List<EventTrigger>();

            	moanTriggers.Add(new EventTrigger(this,"L1 trigger"));
            	moanTriggers[0].handler = this;
            	moanTriggers.Add(new EventTrigger(this,"L2 trigger"));
            	moanTriggers[1].handler = this;
            	moanTriggers.Add(new EventTrigger(this,"L3 trigger"));
            	moanTriggers[2].handler = this;
            	moanTriggers.Add(new EventTrigger(this,"L4 trigger"));
            	moanTriggers[3].handler = this;
            	moanTriggers.Add(new EventTrigger(this,"L5 Orgasm"));
            	moanTriggers[4].handler = this;
            	moanTriggers.Add(new EventTrigger(this,"L0 trigger"));
            	moanTriggers[5].handler = this;

            	StartCoroutine(LoadUIAssets());
            	
            	// JSONStorableString
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=320f;


				// JSONStorableToggle *** Sample Sound cheak box **** 
				sampleMoan = new JSONStorableBool("Use sample Moan Sound", false);
				RegisterBool(sampleMoan);
				CreateToggle(sampleMoan, false);

            	// JSONStorableToggle *** AutoLoop to Idole **** 
            	AutoToIdole = new JSONStorableBool("AutoLoop to Idole", false);
            	
            	// reLoadLibrary
				manualSwTrigger = new JSONStorableAction("unLoadLibrary",unLoadLibrary);
            	dbutton = CreateButton("unLoadLibrary");
				manualSwTrigger.dynamicButton = dbutton;

            	// reLoadLibrary
				manualSwTrigger = new JSONStorableAction("loadLibrary",loadLibrary);
            	dbutton = CreateButton("loadLibrary");
				manualSwTrigger.dynamicButton = dbutton;

            	
            	// Orgasm trigger
				manualSwTrigger = new JSONStorableAction("Orgasm Set",() =>
					{
						openPanel(4);
					});
            	dbutton = CreateButton("Orgasm Set");
				dbutton.buttonColor = new Color(0.9f, 0.739f, 0.9f,1.000f);
            	manualSwTrigger.dynamicButton = dbutton;

            	

            	
            	
            	// JSONStorableStringChooser *** Target Collection Select ***
				List<string> choices = new List<string>();
				choices.Add("#99   AutoLevel");
            	choices.Add("#00   L01");
				choices.Add("#01   L02");
				choices.Add("#02   L03");
				choices.Add("#03   L04");
				choices.Add("#04   L05");
            	choices.Add("#05   E01");
            	choices.Add("#06   E02");
            	choices.Add("#07   E03");

            	JSONStorableStringChooser targetCollection = new JSONStorableStringChooser("targetCollection", choices, "#99   AutoLevel", "Target\nCollection", ChooserCallback);
				RegisterStringChooser(targetCollection);
            	UIDynamicPopup udp = CreatePopup(targetCollection, true);
				udp.labelWidth = 200f;

            	// Arousal reset
				manualSwTrigger = new JSONStorableAction("arousalReset",() =>
					{
					ArousalCount = 0f;
					ArousalLVL = 5;

					});
            	RegisterAction(manualSwTrigger);
            	dbutton = CreateButton("arousalReset",true);
            	dbutton.buttonColor = new Color(0.9f, 0.739f, 0.9f,1.000f);
				manualSwTrigger.dynamicButton = dbutton;
            	
            	// playRandumShot(IfClear)
				manualSwTrigger = new JSONStorableAction("playIfClear",playRandumShot);
				RegisterAction(manualSwTrigger);
            	dbutton = CreateButton("playIfClear",true);
				manualSwTrigger.dynamicButton = dbutton;

            	// playRandumNext(Next)
				manualSwTrigger = new JSONStorableAction("playNext",playRandumNext);
				RegisterAction(manualSwTrigger);
            	dbutton = CreateButton("playNext",true);
				manualSwTrigger.dynamicButton = dbutton;

            	// playRandumLoop
            	playLoopState = new JSONStorableBool("playLoopState",false,playLoopBool);
            		
            	RegisterBool(playLoopState);
            	playLoopState.val = false;
            	
            	manualSwTrigger = new JSONStorableAction("playLoop",()=>
            		{
            			playLoopState.val = (playLoopState.val==true)? false:true;
						StartCoroutine("playRandumLoop");
					});
            	loopDbutton = CreateButton("playLoop",true);
				manualSwTrigger.dynamicButton = loopDbutton;

            	manualSwTrigger = new JSONStorableAction("OrgasmTest",() =>
					{
						triggerTest(4);
					});
            	dbutton = CreateButton("OrgasmTest",true);
				dbutton.buttonColor = new Color(0.9f, 0.739f, 0.9f,1.000f);
            	manualSwTrigger.dynamicButton = dbutton;

            
            	// JSONStorableString 
				PluginInfo = new JSONStorableString("PluginInfo", "" );
				dtext = CreateTextField(PluginInfo,true);
				dtext.height=30f;

            }
			catch (Exception e)
			{
    	    	SuperController.LogError("Exception caught: " + e);
	        }

        	

        }

		private JSONStorableString PluginInfo;
		private UIDynamicTextField dtext;
		private JSONStorableString jstring;
    	protected UIDynamicButton dbutton;
    	protected UIDynamicButton loopDbutton;
    	JSONStorableAction manualSwTrigger;
		private UIDynamicSlider dslider;
    	

    	protected void openPanel(int i) {
			moanTriggers[i].OpenTriggerActionsPanel();
    	}
    	
    	private void ChooserCallback(string s){
    		choiceColection = s;
    	}

    	private void unLoadLibrary(){
    		
    		NamedAudioClip clip;

    		foreach ( List<string> lib in audioLib ){
    			lib.ForEach((string clipName) =>
    				{
    					clip = URLAudioClipManager.singleton.GetClip(clipName);
    					URLAudioClipManager.singleton.RemoveClip(clip);

    				});
    		}

    		Array.Clear(audioLib,0,8);
    		
    	}
    	

    	private void loadLibrary() {
    		audioLib[0] = new List<string>(); audioLib_count[0] = ImportFolder("Custom/Sounds/moanLight/L01",audioLib[0]);
    		audioLib[1] = new List<string>(); audioLib_count[1] = ImportFolder("Custom/Sounds/moanLight/L02",audioLib[1]);
    		audioLib[2] = new List<string>(); audioLib_count[2] = ImportFolder("Custom/Sounds/moanLight/L03",audioLib[2]);
    		audioLib[3] = new List<string>(); audioLib_count[3] = ImportFolder("Custom/Sounds/moanLight/L04",audioLib[3]);
			audioLib[4] = new List<string>(); audioLib_count[4] = ImportFolder("Custom/Sounds/moanLight/L05",audioLib[4]);
			audioLib[5] = new List<string>(); audioLib_count[5] = ImportFolder("Custom/Sounds/moanLight/E01",audioLib[5]);
			audioLib[6] = new List<string>(); audioLib_count[6] = ImportFolder("Custom/Sounds/moanLight/E02",audioLib[6]);
			audioLib[7] = new List<string>(); audioLib_count[7] = ImportFolder("Custom/Sounds/moanLight/E03",audioLib[7]);
   		}
    	
    	
    	void  Start() {


    		/*********** Init Fail Recover *****/
    		if(sensitiv == 0f) sensitiv = 0.5f;
    		if(moanLib == "" | moanLib == null ) moanLib = "-- no select --";
    		if(choiceColection == null ) choiceColection = "#99   AutoLevel";
    		
//    		SuperController.LogError("Start choiceColection/moanLib/sensitiv: " +  choiceColection + "/" + moanLib + "/" +  sensitiv);


    		ArousalCount = 0f;
    		ArousalLVL = 5;

    		headAudioSource = containingAtom.GetStorableByID("HeadAudioSource") as AudioSourceControl;
    		
    		loadLibrary();
    		
			/*********** Expression idoling **************/			
			StartCoroutine("coolCheak");
    	}

   		IEnumerator coolCheak() {

   			while (true) {

   				if((Time.time - lastCountTime)>6f){
   					if(ArousalLVL != 5){
   						if(moanTriggers[5] != null ){
   							moanTriggers[5].active = true;		// *** idole trigger
   							moanTriggers[5].active = false;
   							ArousalLVL = 5;
							playLoopState.val = false;
   						}
   					}
   					ArousalCount = ((ArousalCount - (int)(Time.time - lastCountTime))<0 )? 0: ArousalCount - (Time.time - lastCountTime);
   				}
   				yield return new WaitForSeconds (10f);
        	}
	    }
    	
    	protected void triggerTest(int i)
    	{
			moanTriggers[i].active = true;
			moanTriggers[i].active = false;    		

    	}
    	void OnDestroy()
        {
        	foreach(EventTrigger targetTrg in moanTriggers){
        		targetTrg.Remove();
        	}
        }
		
    ////////////////////////////////////////////////////////////////////
	//
	// Nemech Audio
	//
	////////////////////////////////////////////////////////////////////
    	
    	// Usage
    	//    	private List<string> audioLib01 = new List<string>();
    	//		private int audioLib01_count = 0;
    	//		private int bkSound;
		//
    	//   private AudioSourceControl headAudioSource;
    	//   headAudioSource = containingAtom.GetStorableByID("HeadAudioSource") as AudioSourceControl;
    	//   audioLib01_count = ImportFolder("Custom/Sounds/Library01/L1",audioLib01);
    	//
    	//   playRandumShot();
		//   playRandumNext();
    	

    	
    	
        private int ImportFolder(string path ,List<string> tgtLib )
        {

        	int rval = 0;
        	string workPath = "";
        	
        	try
            {
            	string pathVal = path;
            	if (path == "") return 0;

            	if(sampleMoan.val == true){ // sampleMoan 使用
            		MVRPluginManager _manager = containingAtom.GetComponentInChildren<MVRPluginManager>();
            		foreach (Transform transform in _manager.pluginListPanel){
            			var urlTransform = transform.Find("Panel").Find("URL").GetComponent<Text>().text;
            			if( urlTransform.Contains("NeMech.moan") ) workPath = urlTransform;
            		}
            		
            		if(workPath.Contains(":")){
            			pathVal = workPath.Substring(0,workPath.IndexOf(":")) + ":/" + path ;
            		}
            	} else {					// ライブラリ指定の確認
            		if(moanLib != "" && moanLib != "-- no select --" ){
            			pathVal = moanLib.Substring(0,moanLib.IndexOf(".var")) + ":/" + path;
            			if(FileManagerSecure.DirectoryExists(pathVal) == false){
            				SuperController.LogError("moan library folder not found: " + path );
            				return 0;
            			}
            		}
            	}
            	path= pathVal;
            	var files = SuperController.singleton.GetFilesAtPath(path).ToList();
            	files.ForEach((string fileName) =>
                {
                	if( fileName.Contains(".mp3"))
                		Load(fileName);
	                	tgtLib.Add(FileManagerSecure.GetFileName(fileName));
                	rval ++;
                });
            }
            catch (Exception e)
            {
                SuperController.LogError("ImportFolder Error" );
            }
        	return rval;
        }

    	private static URLAudioClip Load(string path)
        {
        	var existing = URLAudioClipManager.singleton.GetClip(path);
        	return existing != null ? null : URLAudioClipManager.singleton.QueueClip(SuperController.singleton.NormalizeMediaPath(path));
        }

    	private void playRandumShot(){

    		int colectNum = int.Parse(choiceColection.Substring(1,2));
    		if(colectNum == 99){
    			colectNum = autoArousal();
    		}

    		if(headAudioSource.playingClip != null | audioLib_count[colectNum] == 0){ // 再生中 または再生可能音声数 0
				return ;
    		}
    		int randNum = (int) UnityEngine.Random.Range(0,audioLib_count[colectNum]);
    		while(bkSound == randNum){
	    		randNum = (int) UnityEngine.Random.Range(0,audioLib_count[colectNum]);
    		}
    		bkSound = randNum;

    		NamedAudioClip clip = URLAudioClipManager.singleton.GetClip(audioLib[colectNum][randNum]);
    		headAudioSource.PlayIfClear(clip);
    		return ;
    	}

    	private void playRandumNext(){

    		
    		int colectNum = int.Parse(choiceColection.Substring(1,2));
    		if(colectNum == 99){
   				colectNum = autoArousal();
    		}
    		
    		if( audioLib_count[colectNum] == 0) return; // 再生可能音声数 0

    		
    		int randNum = (int) UnityEngine.Random.Range(0,audioLib_count[colectNum]);
    		while(bkSound == randNum){
	    		randNum = (int) UnityEngine.Random.Range(0,audioLib_count[colectNum]);
    		}
    		bkSound = randNum;

    		NamedAudioClip clip = URLAudioClipManager.singleton.GetClip(audioLib[colectNum][randNum]);
    		headAudioSource.PlayNext(clip);
    		return ;
    	}
    	
    	private void playLoopBool(JSONStorableBool jf){
    		if(jf.val == true && headAudioSource.playingClip != null){
    			StartCoroutine("playEndWait");
				return ;
    		}
    		StartCoroutine("playRandumLoop");
    	}
    	
    	IEnumerator playEndWait(){
    		playLoopState.val = false;
    		
    		while(headAudioSource.playingClip != null){ //再生終了まで待機して再生。
    			yield return new WaitForSeconds (1f);
    			playLoopState.val = false;
    		}
    		playLoopState.val = true;
    		StartCoroutine("playRandumLoop");
    	}
    	
   		IEnumerator playRandumLoop() {
			int randNum;
   			int colectNumPlay;
   			

   			if(playLoopState.val == false ){ // LOOP停止のコマンド
   				yield return new WaitForSeconds (1f);
				loopDbutton.buttonColor=new Color(0.839f, 0.839f, 0.839f,1.000f);
   				yield break ;
   			}

			loopDbutton.buttonColor=Color.green;

    		int colectNum = int.Parse(choiceColection.Substring(1,2)); // プレイモードを保持する。

   			while (playLoopState.val) {


   				if(headAudioSource.playingClip == null) { // 再生中はパス

   					if(colectNum == 99){
   						colectNumPlay = autoArousal(true);
   					} else
   						colectNumPlay = colectNum;
   					
   					if(audioLib_count[colectNumPlay] == 0){ // 音源無のループはできない。
   						playLoopState.val = false;
   						loopDbutton.buttonColor=new Color(0.839f, 0.839f, 0.839f,1.000f);
		   				yield break ;
   					}
   					randNum = (int) UnityEngine.Random.Range(0,audioLib_count[colectNumPlay]);
		    		while(bkSound == randNum){
	    			randNum = (int) UnityEngine.Random.Range(0,audioLib_count[colectNumPlay]);
		    		}
   					bkSound = randNum;

   					NamedAudioClip clip = URLAudioClipManager.singleton.GetClip(audioLib[colectNumPlay][randNum]);
   					headAudioSource.PlayIfClear(clip);
   					
   					if(colectNumPlay == 4) {
   						playLoopState.val = false; // オーガズムによる終了
						loopDbutton.buttonColor=new Color(0.839f, 0.839f, 0.839f,1.000f);
   					}
   				}

   				yield return new WaitForSeconds (1f);
        	}
	    }
    	
    	private int autoArousal(bool FromLoop = false){
			int rval;
    		ArousalCount += sensitiv ;
    		if(AutoToIdole.val != true )
	    		lastCountTime = Time.time;
    		else if( FromLoop != true)
	    		lastCountTime = Time.time;

    		if(ArousalCount >= MaxArousalCount){
    			ArousalCount = 0;
    			rval = 4;
   				if(ArousalLVL != rval){
   					if(moanTriggers[rval] != null ){
   						moanTriggers[rval].active = true;
   						moanTriggers[rval].active = false;
  						ArousalLVL = rval;
   					}
   				}
    		} else if (ArousalCount > ArousalLV3){
				rval = 3;
   				if(ArousalLVL != rval){
   					if(moanTriggers[rval] != null ){
   						moanTriggers[rval].active = true;
   						moanTriggers[rval].active = false;
  						ArousalLVL = rval;
   					}
   				}
    		} else if (ArousalCount > ArousalLV2){
    			rval = 2;
   				if(ArousalLVL != rval){
   					if(moanTriggers[rval] != null ){
   						moanTriggers[rval].active = true;
   						moanTriggers[rval].active = false;
  						ArousalLVL = rval;
   					}
   				}
    		} else if (ArousalCount > ArousalLV1){
				rval = 1;
   				if(ArousalLVL != rval){
   					if(moanTriggers[rval] != null ){
   						moanTriggers[rval].active = true;
   						moanTriggers[rval].active = false;
  						ArousalLVL = rval;
   					}
   				}
    		} else {
				rval = 0;
   				if(ArousalLVL != rval){
   					if(moanTriggers[rval] != null ){
   						moanTriggers[rval].active = true;
   						moanTriggers[rval].active = false;
  						ArousalLVL = rval;
   					}
   				}
    		}
    		PluginInfo.val = "Arousal Level: " + ArousalLVL + "\nArousal Count: " + ArousalCount;

    		return rval;
    	}
    	
    ////////////////////////////////////////////////////////////////////
	//
	// The following source was borrowed from TriggerControl.cs in MeshedVR Sample.
	//
	////////////////////////////////////////////////////////////////////

		// Validate is called when storables are removed. This cleans up destroyed trigger references

    	public override void Validate() {
			base.Validate();
    		foreach(EventTrigger targetTrigger in moanTriggers){
				if(targetTrigger != null) targetTrigger.Validate();
			}

		}

		// this function allows trigger atom references to be updated when an atom is renamed
		protected void OnAtomRename(string oldid, string newid) {

			foreach(EventTrigger targetTrigger in moanTriggers){
				if(targetTrigger != null) targetTrigger.SyncAtomNames();
			}
			
		}

    	/***** for TriggerHandler *****/
		protected RectTransform triggerActionsPrefab;
		protected RectTransform triggerActionMiniPrefab;
		protected RectTransform triggerActionDiscretePrefab;
		protected RectTransform triggerActionTransitionPrefab;

    	public void RemoveTrigger(Trigger trigger) {
			// do nothing as we only manage single trigger here
		}
		public void DuplicateTrigger(Trigger trigger) {
			// do nothing as we only manage single trigger here
		}
		public RectTransform CreateTriggerActionsUI() {
			RectTransform rt = null;
			if (triggerActionsPrefab != null) {
				rt = (RectTransform)Instantiate(triggerActionsPrefab);
			} else {
				Debug.LogError("Attempted to make TriggerActionsUI when prefab was not set");
			}
			return (rt);
		}

		public RectTransform CreateTriggerActionMiniUI() {
			RectTransform rt = null;
			if (triggerActionMiniPrefab != null) {
				rt = (RectTransform)Instantiate(triggerActionMiniPrefab);
			} else {
				Debug.LogError("Attempted to make TriggerActionMiniUI when prefab was not set");
			}
			return (rt);
		}

		public RectTransform CreateTriggerActionDiscreteUI() {
			RectTransform rt = null;
			if (triggerActionDiscretePrefab != null) {
				rt = (RectTransform)Instantiate(triggerActionDiscretePrefab);
			} else {
				Debug.LogError("Attempted to make TriggerActionDiscreteUI when prefab was not set");
			}
			return (rt);
		}
		public RectTransform CreateTriggerActionTransitionUI() {
			RectTransform rt = null;
			if (triggerActionTransitionPrefab != null) {
				rt = (RectTransform)Instantiate(triggerActionTransitionPrefab);
			} else {
				Debug.LogError("Attempted to make TriggerActionTransitionUI when prefab was not set");
			}
			return (rt);
		}

		public void RemoveTriggerActionUI(RectTransform rt) {
			if (rt != null) {
				Destroy(rt.gameObject);
			}
		}

//    }

    ////////////////////////////////////////////////////////////////////
	//
	// 
	//
	////////////////////////////////////////////////////////////////////

    	
  		public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
		{
			JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
			if (includePhysical || forceStore)
			{
				needsStore = true;

				jc["moanLib"] = moanLib;
				jc["sensitiv"] = sensitiv.ToString();
				jc["atIdole"] = AutoToIdole.val.ToString();
				foreach(EventTrigger evtTrigger in moanTriggers){
					jc[evtTrigger.Name] = evtTrigger.GetJSON();
				}
			}
			return jc;
		}

		public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
		{
			base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);
			if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
			{
				moanLib = jc["moanLib"];
				sensitiv = float.Parse(jc["sensitiv"]);
				atIdole = bool.Parse(jc["atIdole"]);

				foreach(EventTrigger evtTrigger in moanTriggers){
					evtTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
				}

			}
		}
	
    ////////////////////////////////////////////////////////////////////
	//
	// FromMesh VR
	//
	////////////////////////////////////////////////////////////////////
	
		// Wrapper for easier handling of custom triggers.
		public class EventTrigger : Trigger
		{
			public string Name {
				get { return name; }
				set { name = value; myNeedInit = true; }
			}

			public MVRScript Owner {
				get; private set;
			}

			private string name;
			private bool myNeedInit = true;

			public EventTrigger(MVRScript owner, string name)
			{
				Name = name;
				Owner = owner;
			}

			public void RestoreFromJSON(JSONClass jc, string subScenePrefix, bool isMerge, bool setMissingToDefault)
			{
				if (jc.HasKey(Name))
				{
					JSONClass tc = jc[Name].AsObject;
					if (tc != null)
						base.RestoreFromJSON(tc, subScenePrefix, isMerge);
				}
				else if (setMissingToDefault)
				{
					base.RestoreFromJSON(new JSONClass());
				}
			}

			public void Trigger()
			{
				active = true;
				active = false;
			}
			
			public void TriggerTransition(float val)
			{
				this.transitionInterpValue = val;
			}
		}
		// Wrapper for easier handling of custom triggers. end
    	
    	
		protected IEnumerator LoadUIAssets() {
			AssetBundleLoadAssetOperation request = AssetBundleManager.LoadAssetAsync("z_ui2", "TriggerActionsPanel", typeof(GameObject));
			if (request == null) {
				SuperController.LogError("Request for TriggerActionsPanel in z_ui2 assetbundle failed");
				yield break;
			}
			yield return request;
			GameObject go = request.GetAsset<GameObject>();
			if (go == null) {
				SuperController.LogError("Failed to load TriggerActionsPanel asset");
			}
			triggerActionsPrefab = go.GetComponent<RectTransform>();
			if (triggerActionsPrefab == null) {
				SuperController.LogError("Failed to load TriggerActionsPanel asset");
			}

			request = AssetBundleManager.LoadAssetAsync("z_ui2", "TriggerActionMiniPanel", typeof(GameObject));
			if (request == null) {
				SuperController.LogError("Request for TriggerActionMiniPanel in z_ui2 assetbundle failed");
				yield break;
			}
			yield return request;
			go = request.GetAsset<GameObject>();
			if (go == null) {
				SuperController.LogError("Failed to load TriggerActionMiniPanel asset");
			}
			triggerActionMiniPrefab = go.GetComponent<RectTransform>();
			if (triggerActionMiniPrefab == null) {
				SuperController.LogError("Failed to load TriggerActionMiniPanel asset");
			}

			request = AssetBundleManager.LoadAssetAsync("z_ui2", "TriggerActionDiscretePanel", typeof(GameObject));
			if (request == null) {
				SuperController.LogError("Request for TriggerActionDiscretePanel in z_ui2 assetbundle failed");
				yield break;
			}
			yield return request;
			go = request.GetAsset<GameObject>();
			if (go == null) {
				SuperController.LogError("Failed to load TriggerActionDiscretePanel asset");
			}
			triggerActionDiscretePrefab = go.GetComponent<RectTransform>();
			if (triggerActionDiscretePrefab == null) {
				SuperController.LogError("Failed to load TriggerActionDiscretePanel asset");
			}

			request = AssetBundleManager.LoadAssetAsync("z_ui2", "TriggerActionTransitionPanel", typeof(GameObject));
			if (request == null) {
				SuperController.LogError("Request for TriggerActionTransitionPanel in z_ui2 assetbundle failed");
				yield break;
			}
			yield return request;
			go = request.GetAsset<GameObject>();
			if (go == null) {
				SuperController.LogError("Failed to load TriggerActionTransitionPanel asset");
			}
			triggerActionTransitionPrefab = go.GetComponent<RectTransform>();
			if (triggerActionTransitionPrefab == null) {
				SuperController.LogError("Failed to load TriggerActionTransitionPanel asset");
			}
			
		}
		public override void InitUI() {
			base.InitUI();
			if (UITransform != null) {
				foreach(EventTrigger opeGUI in moanTriggers){
					opeGUI.triggerActionsParent = UITransform;
				}
				
			}
		}
   		protected float timer = 0f;

	}
	
}
